/// <reference types="node" />
import { ImportMap, PackageSource, SnowpackConfig } from '../types';
export declare class PackageSourceV4 implements PackageSource {
    cacheDir: URL;
    config: SnowpackConfig;
    importMap: ImportMap;
    target: 'browser' | 'node-esm' | 'node-cjs';
    mode: 'development' | 'production';
    pkgPrefix: string;
    /** packages to always bundle (i.e. don’t mark as "external") */
    private alwaysBundle;
    constructor(config: SnowpackConfig);
    prepare(): Promise<void>;
    prepareSingleFile(fileLoc: any): Promise<void>;
    load(id: string): Promise<{
        contents: string | Buffer;
        imports: never[];
    }>;
    resolvePackageImport(originalSpec: any): Promise<string>;
    modifyBuildInstallOptions(opts: any): Promise<any>;
    getCacheFolder(): string;
    clearCache(): Promise<void>;
    /** Given an import specifier, return npm package info, or "undefined" if it’s non-npm */
    private parseSpec;
    /** Build package (with some retry logic) */
    private buildPackage;
    /** Get a package.json manifest and cwd for any spec */
    private findPkg;
    /** Find any npm package’s entrypoints (similar to esinstall’s logic, but moved here to migrate away from esinstall) */
    private findEntryPoints;
    /** Parse & resolve package imports */
    private transformImports;
}
